/**
 * Created by yuanjianxin on 2018/5/10.
 */
const Coder = require('web3/lib/solidity/coder');
const Tx = require('ethereumjs-tx');
module.exports = {


    async getFormatedTx(Web3, contactAddress, fromAddress, funcName, gasLimit = null, types = [], args = []){

        let fullName = funcName + '(' + types.join() + ')';
        let signature = Web3.sha3(fullName).substr(2, 8);
        let data = '0x' + signature + Coder.encodeParams(types, args);

        let nonce = Web3.toHex(Web3.eth.getTransactionCount(fromAddress));

        let gasPrice = Web3.toHex(Web3.eth.gasPrice);

        let gasLimitHex = gasLimit && Web3.toHex(gasLimit) || null;
        let rawTx = {
            nonce,
            gasPrice,
            to: contactAddress,  //合约地址
            data
        };
        gasLimitHex && (rawTx.gasLimit = gasLimitHex);
        return new Tx(rawTx);

    },


    async sendRawTransaction(eth, tx){
        let serializedTx = '0x' + tx.serialize().toString('hex');
        return new Promise((resolve, reject) => {
            eth.sendRawTransaction(serializedTx, (err, res) => {
                err ? reject(err) : resolve(res);
            });
        });
    }

}